/*
 * carl9170 firmware - used by the ar9170 wireless device
 *
 * Firmware command interface definition
 *
 * Copyright (c) 2000-2005 ZyDAS Technology Corporation
 * Copyright (c) 2007-2009 Atheros Communications, Inc.
 * Copyright	2009	Johannes Berg <johannes@sipsolutions.net>
 * Copyright 2009, 2010 Christian Lamparter <chunkeey@googlemail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __CARL9170FW_CMD_H
#define __CARL9170FW_CMD_H

#include "compiler.h"
#include "types.h"

#include "fwcmd.h"

static inline void __check(void)
{
	BUILD_BUG_ON(sizeof(struct ar9170_cmd) != CARL9170_MAX_CMD_LEN);
	BUILD_BUG_ON(sizeof(struct ar9170_rsp) != CARL9170_MAX_CMD_LEN);
	BUILD_BUG_ON(sizeof(struct ar9170_set_key_cmd) != AR9170_SET_KEY_CMD_SIZE);
	BUILD_BUG_ON(sizeof(struct ar9170_disable_key_cmd) != AR9170_DISABLE_KEY_CMD_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_rf_init) != CARL9170_RF_INIT_SIZE);
	BUILD_BUG_ON(sizeof(struct ar9170_rf_init_result) != AR9170_RF_INIT_RESULT_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_tx_stuck_rsp) != CARL9170_TX_STUCK_RSP_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_tx_stuck_cmd) != CARL9170_TX_STUCK_CMD_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_watchdog_cmd) != CARL9170_WATCHDOG_CMD_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_psm_cmd) != CARL9170_PSM_CMD_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_tx_status) != CARL9170_TX_STATUS_SIZE);
	BUILD_BUG_ON(sizeof(struct _carl9170_tx_status) != CARL9170_TX_STATUS_SIZE);
	BUILD_BUG_ON(sizeof(struct __ar9170_tx_status) != AR9170_TX_STATUS_SIZE);
	BUILD_BUG_ON(sizeof(struct carl9170_gpio) != CARL9170_GPIO_SIZE);
}

void handle_cmd(struct ar9170_rsp *resp);
void __attribute__((noreturn)) reboot(void);

#endif /* __CARL9170FW_CMD_H */
